import { Aggregate } from '../Aggregate';
export declare abstract class EventExecutor<E, A extends Aggregate> {
    static getEventExecutor(event: any, eventExecutors: EventExecutor<any, any>[]): EventExecutor<any, any>;
    aggregateIdProperty: string;
    aggregateType: string;
    aggregateCreating: boolean;
    constructor(aggregateCreating?: boolean, aggregateIdProperty?: string, aggregateType?: string);
    abstract canExecute(event: any): boolean;
    abstract apply(event: E, aggregate: A): any;
    abstract getEventId(event: E): string;
    /**
     * Depending on event definition, set ordinal in event.
     * @param event
     * @param ordinal
     */
    protected abstract setEventOrdinal(event: E, ordinal: number): any;
    /**
     * Event ordinal is used by optimistic locking.
     * Event ordinal could also be used to support snapshot.
     * By default return 0 if events do not have oridnal property.
     * @param event
     * @returns number
     */
    abstract getEventOrdinal(event: E): number;
    /**
     * Update event with the next event ordinal if the event has ordinal 0.
     * @param event
     * @param aggregate
     */
    updateEventOrdinal(event: E, ordinal: number): void;
    isAggregateCreating(): boolean;
    getAggregateType(): string;
    getAggregateId(event: E): string;
}
